#coding: utf-8
import sys
import threading

import wx

from lib.socket.ClientWebSocket import ClientWebSocket


class HomeArea():
    def __init__(self, frame):
        self.frame = frame
        self.wsUrl = "ws://api-test.vandyo.com/mirror/websocket/"                    # webosocket 连接地址
        self.devCode = "868142043390091"                                              # 设备id
        self.ws = None
        self.mainPanel = None

        self.wsUrlText = None                                                        # webSocket 连接地址文本框
        self.devCodeText = None                                                      # 设备号文本框
        self.logTextCtr = None                                                       # 日志显示框

    def setWsUrl(self,data):
        self.wsUrl = data
    def setDevCode(self,data):
        self.devCode = data

    #################################################
    #       创建一个顶级pannel
    #################################################
    def create(self):
        self.mainPanel = wx.Panel(self.frame)
        boxSizer = wx.BoxSizer(wx.VERTICAL)
        topPanel = self.getTopPanel()

        bottomPanel = self.getBottomPanel()
        boxSizer.Add(topPanel,1,flag=wx.EXPAND | wx.ALL)
        boxSizer.Add(bottomPanel,2, flag=wx.EXPAND | wx.TOP , border=5)
        self.mainPanel.SetSizer(boxSizer)
        return self.mainPanel

    def getTopPanel(self):
        topPanel = wx.Panel(self.mainPanel)
        # topPanel.SetBackgroundColour("PINK")
        wx.StaticText(topPanel, label='连接地址：', pos=(10, 10))
        self.wsUrlText = wx.TextCtrl(topPanel, pos=(70, 5), size=wx.Size(355, -1), value=self.wsUrl)
        wx.StaticText(topPanel, label='设备 号：', pos=(430, 10))
        self.devCodeText = wx.TextCtrl(topPanel, pos=(485, 5), size=wx.Size(120, -1), value=self.devCode)
        setDevCodeButton = wx.Button(topPanel, label="设置设备号", pos=(610, 5))
        connectButton = wx.Button(topPanel, label="连接设备", pos=(695, 5))
        self.frame.Bind(wx.EVT_BUTTON, lambda evt: self.connect(evt),
                        connectButton)
        disConnectButton = wx.Button(topPanel, label="断开连接", pos=(775, 5))
        self.frame.Bind(wx.EVT_BUTTON, lambda evt: self.disConnect(evt),
                        disConnectButton)
        wx.StaticText(topPanel, label='状态：',pos=(855, 10))
        self.connectStatusText = wx.TextCtrl(topPanel, pos=(895, 5), size=wx.Size(80, -1), value="未连接",style=wx.TE_READONLY)
        self.connectStatusText.SetForegroundColour(wx.RED)

        connectButton1 = wx.Button(topPanel, label="连接设备", pos=(695, 100))

        return topPanel

    #################################################
    #       获取底部pannel的内容
    #################################################
    def getBottomPanel(self):
        bottomPanel = wx.Panel(self.mainPanel)
        boxSizer_bottom = wx.BoxSizer(wx.HORIZONTAL)
        logArea = wx.Panel(bottomPanel)
        logStaticText = wx.StaticText(logArea, label='日志：')
        self.logTextCtr = wx.TextCtrl(logArea, size=wx.Size(40, -1),style=wx.TE_MULTILINE)
        sys.stdout = self.logTextCtr
        sys.stderr = self.logTextCtr
        boxSizer_logArea = wx.BoxSizer(wx.VERTICAL)
        boxSizer_logArea.Add(logStaticText, 2, flag=wx.EXPAND | wx.TOP ,border=10)
        boxSizer_logArea.Add(self.logTextCtr, 100, flag=wx.EXPAND | wx.ALL)
        logArea.SetSizer(boxSizer_logArea)

        ctrArea = wx.Panel(bottomPanel)
        ctrText = wx.StaticText(ctrArea, label='控制：')
        ctrPanel = wx.Panel(ctrArea, style=wx.BORDER_SIMPLE)
        clearLogButton = wx.Button(ctrPanel, label="清空日志", pos=(5, 5))
        self.frame.Bind(wx.EVT_BUTTON, lambda evt: self.clearLog(evt),
                        clearLogButton)
        boxSizer_ctrArea = wx.BoxSizer(wx.VERTICAL)
        boxSizer_ctrArea.Add(ctrText,2, flag=wx.EXPAND | wx.TOP ,border=10)
        boxSizer_ctrArea.Add(ctrPanel,100, flag=wx.EXPAND | wx.ALL)
        ctrArea.SetSizer(boxSizer_ctrArea)

        boxSizer_bottom.Add(logArea,70,flag=wx.EXPAND | wx.ALL)
        boxSizer_bottom.Add(ctrArea, 30, flag=wx.EXPAND | wx.LEFT,border=10)
        bottomPanel.SetSizer(boxSizer_bottom)

        return  bottomPanel

    #################################################
    #       连接设备
    #################################################
    def connect(self,evt):
        sys.stdout = self.logTextCtr
        sys.stderr = self.logTextCtr
        self.ws = ClientWebSocket()
        self.ws.setWsUrl(self.wsUrlText.GetValue())
        self.ws.setWsCode(self.devCodeText.GetValue())
        threadObj = threading.Thread(target=self.doConnect, args=())
        threadObj.start()
    def doConnect(self):
        self.ws.connect()


    #################################################
    #       断开连接
    #################################################
    def disConnect(self,evt):
        self.ws.close()

    #################################################
    #       清空日志
    #################################################
    def clearLog(self,evt):
        self.logTextCtr.SetValue("")

